#include <windows.h>
#include <direct.h>
#include "seamless3d.h"
#include "gui.h"
#include "ms-gui.h"

#ifdef RECORD_SOUNDMOVIE

//#define NUM_NOTIFICATIONS  16
#define NUM_NOTIFICATIONS  2
//#include <dsound.h>
//#pragma   comment(lib,"dsound.lib")

extern HWND hWndMain;
int g_numOfChannels = 2; //1 = mono, 2 = stereo

bool g_realTimeAudioSynth = false;

extern Ptr<VideoControlPanel> g_vcp;

DWORD g_dwCaptureBufferSize = 0;
DWORD g_bufferNextOffset = 0;
DWORD g_dwNotifySize = 0;
HANDLE g_hNotificationEvent;
int g_fps = 25; //5 //standard
int g_numOfSeconds = 10;

int g_sampleRate = 48000; //44100;

//String g_mainFilename = "frame";
//String g_mainFilename = "F:\\Vlogs\\animated-character\\march-vlog\\real-thyme\\frame";
String g_mainFilename;// = "F:\\Vlogs\\animated-character\\march-vlog\\clip0005\\frame";

int g_counter = 0;
unsigned int g_remCounter = 0;
unsigned int g_numOfFrames = g_fps * g_numOfSeconds;
unsigned short int* g_frameBufferS = 0;
Pix24* g_frameBuffer = 0;
unsigned int g_frameSizeS = 0;
unsigned int g_frameSize = 0;
unsigned int g_frameBufferSLen = 0;
unsigned int g_frameBufferLen = 0;
extern Ptr<_3DWin> g_3d;
void createPNG24(const char* filename, int width, int height, Pix24* pixels);
bool g_recordSoundMovie = false; //true = single shot
bool g_playSoundMovie = false;


extern bool mouse3dMode;
extern bool g_viewPosDragMode;
extern bool g_viewRotDragMode;
extern bool g_viewZRotDragMode;
short int* g_playBuf = 0;
int g_playBufLen = 0;
int g_playBufferIndex = 0;
bool g_playing = false;


void updateBuffer(){
}

void initSoundCapture(){
}


void initPlaySound(){
}

extern int g_clipCounter;
extern int g_frame;

void saveScreenshotToMem(unsigned int* pBits, unsigned int screenWidth, unsigned int width, unsigned int height, Pix24* lpDest){

	//if(g_clipCounter == 1 && g_frame == 300){
	//	int c = 0;
	//}

	for(unsigned int r = 0; r < height; r++){
		for(unsigned int c = 0; c < width; c++){
			int idx = r * width + c;
			unsigned int rawPix = pBits[r * screenWidth + c];
			Pix24 pixel;
			pixel.b = rawPix & 0x00ff;
			rawPix >>= 8;
			pixel.g = rawPix & 0x00ff;
			rawPix >>= 8;
			pixel.r = rawPix & 0x00ff;
			lpDest[idx] = pixel;
		}
	}
	if(g_settings->screenshotMouse && g_currentType2){
		if(g_viewPosDragMode || g_viewRotDragMode || g_viewZRotDragMode){
			pasteSprite(g_mousePos.x - 11, g_mousePos.y - 11, 24 * 16, 209, width, height, iconSrcBufCX, iconSrcBufCY, 24, 24, lpDest);
		}
		else if(mouse3dMode == false){
			if(g_currentType2 == g_crossCursor){
				pasteSprite(g_mousePos.x - 11, g_mousePos.y - 11, 24 * 16, 209, width, height, iconSrcBufCX, iconSrcBufCY, 24, 24, lpDest);
			}
			else if(g_currentType2 == g_lockedOnPointCursor){
				pasteSprite(g_mousePos.x - 11, g_mousePos.y - 11, 24 * 12, 209, width, height, iconSrcBufCX, iconSrcBufCY, 24, 24, lpDest);
			}
			else if(g_currentType2 == g_insertLineCursor){
				pasteSprite(g_mousePos.x - 2, g_mousePos.y - 30, 32 * 3, 305, width, height, iconSrcBufCX, iconSrcBufCY, 32, 32, lpDest);
			}
			else if(g_currentType2 == g_knifeCursor){
				pasteSprite(g_mousePos.x - 2, g_mousePos.y - 30, 32 * 3, 305, width, height, iconSrcBufCX, iconSrcBufCY, 32, 32, lpDest);
			}
			else if(g_currentType2 == g_addGeometryCursor){
				//pasteSprite(g_mousePos.x - 11, g_mousePos.y - 11, 24 * 16, 281, width, height, iconSrcBufCX, iconSrcBufCY, 24, 24, lpDest);
				pasteSprite(g_mousePos.x - 16, g_mousePos.y - 13, 32 * 2, 305, width, height, iconSrcBufCX, iconSrcBufCY, 32, 32, lpDest);
			}
			else if(g_currentType2 == g_addGeometryMirrorCursor){
				//pasteSprite(g_mousePos.x - 11, g_mousePos.y - 11, 24 * 15, 281, width, height, iconSrcBufCX, iconSrcBufCY, 24, 24, lpDest);
				pasteSprite(g_mousePos.x - 16, g_mousePos.y - 13, 32 * 1, 305, width, height, iconSrcBufCX, iconSrcBufCY, 32, 32, lpDest);
			}
			else if(g_currentType2 == g_addPointCursor){
				pasteSprite(g_mousePos.x - 11, g_mousePos.y - 11, 24 * 14, 209, width, height, iconSrcBufCX, iconSrcBufCY, 24, 24, lpDest);
			}
			else if(g_currentType2 == g_ringSelectCursor){
				pasteSprite(g_mousePos.x - 7, g_mousePos.y - 7, 32 * 0, 305, width, height, iconSrcBufCX, iconSrcBufCY, 32, 32, lpDest);
			}
			else if(g_currentType2 == g_addBoneCursor){
				pasteSprite(g_mousePos.x - 7, g_mousePos.y - 7, 32 * 4, 305, width, height, iconSrcBufCX, iconSrcBufCY, 32, 32, lpDest);
			}
			else if(g_currentType2 == g_insertBoneCursor){
				pasteSprite(g_mousePos.x - 7, g_mousePos.y - 7, 32 * 5, 305, width, height, iconSrcBufCX, iconSrcBufCY, 32, 32, lpDest);
			}
			else{
				pasteSprite(g_mousePos.x, g_mousePos.y, 469, 209, width, height, iconSrcBufCX, iconSrcBufCY, 11, 21, lpDest);
			}
		}
	}
}

void saveFrameToMem(unsigned int* pBits, unsigned int screenWidth, unsigned int width, unsigned int height){
	if(g_frameBuffer == 0){
		return;
	}
	int numOfFrams = g_counter - g_remCounter;
	if(numOfFrams < 0){
		numOfFrams += g_numOfFrames;
	}
	for(int k = numOfFrams; --k >= 0;){

		Pix24* lpDest = &g_frameBuffer[g_remCounter * g_frameSize];
		saveScreenshotToMem(pBits, screenWidth, width, height, lpDest);

		g_remCounter++;
		if(g_remCounter == g_numOfFrames){
			g_remCounter = 0;
		}
	}
}

#endif

extern const String g_screenshotDir;

void saveMemToFiles(unsigned int width, unsigned int height){
	SYSTEMTIME ToDaySystemTime;

	GetLocalTime(&ToDaySystemTime);
	char tmpChar[0x200];
	ToDaySystemTime.wYear -= 2000;
	sprintf(tmpChar,"%.2i%.2i%.2i_%.2i%.2i%.2i\\",ToDaySystemTime.wYear, ToDaySystemTime.wMonth, ToDaySystemTime.wDay, ToDaySystemTime.wHour,ToDaySystemTime.wMinute, ToDaySystemTime.wSecond);
	String folder = g_screenshotDir;
	folder += tmpChar;
	mkdir(folder.c_str());
	folder += g_mainFilename;

	String cntrStr;

	for(unsigned int k = 0; k < g_numOfFrames; k++, g_counter++){
		
		if(g_counter == g_numOfFrames){
			g_counter = 0;
		}

		Pix24* pixels = &g_frameBuffer[g_counter * g_frameSize];

		String filename = folder;

		cntrStr = static_cast<int>(k);
		while(cntrStr.length < 4){
			cntrStr = '0' + cntrStr;
		}
		filename += cntrStr;

		filename += ".png";

		createPNG24(filename.c_str(), width, height, pixels);

		//save pcm
		//filename = folder;

		//cntrStr = static_cast<int>(k);
		//while(cntrStr.length < 3){
		//	cntrStr = '0' + cntrStr;
		//}
		//filename += cntrStr;

		//filename += ".pcm";

		//FILE* stream = fopen(filename.c_str(), "w+b");
		//if(stream == 0){
		//	return;
		//}
		//unsigned short int* samples = &g_frameBufferS[g_counter * g_frameSizeS];
		//fwrite(samples, 2, g_frameSizeS, stream);
		//fclose(stream);
	}
}

void exitSoundCapture(){
}


extern bool g_screenshotLate;
extern bool g_screenshotEarly;

void toggleRecordSoundMovie(){

	g_recordSoundMovie = !g_recordSoundMovie;

	if(g_recordSoundMovie){
		g_screenshotLate = false;
		g_screenshotEarly = false;
		if(g_settings->screenshotWindows){
			g_screenshotLate = true;
		}
		else{
			g_screenshotEarly = true;
		}
		initSoundCapture();
	}
	else{
		g_screenshotLate = false;
		g_screenshotEarly = false;
		exitSoundCapture();
	}
}

extern String g_currentFilename;
bool modifyWavFilename(String& filename);

void togglePlaySound(bool state, short int* ibuf, int bufLen){
}

void Anim::setUpSoundPlay(){
	if(soundTrack.length){
		if(Composition* composition = dynamic_cast<Composition*>(soundTrack.refValue()[0].p)){
			g_playBuf = composition->ibuf;
			g_playBufLen = composition->bufLen;
			g_playSoundMovie = true;
			initPlaySound();
		}
	}
}

WAVEFORMATEX wfxInput;

void removeFilename(String& str);
extern String g_currentFilename;



bool initDirectSound2(){
	return true;
}

bool initDirectSound(){
	return true;
}
bool freeDirectSound(){

    return true;
}


bool stopDirectSound(){

    return true;
}


String cntrStr;
extern Ptr<AnimControlPanel> g_acp;
extern int g_animBarListIndex;
extern M_<Anim*> g_animBarList;


int g_aTime = 0;
float g_prevAmp = 0;

void synthBuffer(short int* buffer, int bufferLen){
	float amp = 1.0f - static_cast<float>(g_mousePos.y) / static_cast<float>(720);

	//float peakFreq = 1.0f - static_cast<float>(g_mousePos.x) / static_cast<float>(1280);
	int peakFreq = (g_mousePos.x - 100);

	float fnumOfSamples = bufferLen;
	int numOfHarmonics = 90;
	float volume = .5;

	double ampDiff = amp - g_prevAmp;

	for(int i = 0; i < bufferLen; i++){

		float level = ampDiff / fnumOfSamples * (i + 1) + g_prevAmp;

		float sample = 0;

		float m = 0;
		for(int h = 0; h < numOfHarmonics; h++){
			m += 1;
			int m2 = m * 32;
			if(m2 >= peakFreq - 192 && m2 <= peakFreq + 192){
				float pa = 0;
				if(m2 <= peakFreq){
					pa = 1.0 - float(peakFreq - m2) / 193.0f;
				}
				else if(m2 > peakFreq){
					pa = 1.0 - float(m2 - peakFreq) / 193.0f;
				}

				float f = static_cast<float>((g_aTime + 1) * h) / 220.0;
				float a = level * pa * (1.0f / m);
				sample += volume * a * sinf(f * PI * 2);
			}
		}



		buffer[i] = static_cast<short int>(sample * 0x7fff);
		g_aTime++;
	}

	g_prevAmp = amp;
}


void updatePlayBufferRealTimeSynth(){
}

void updatePlayBuffer(){
}
